//
//  IFS3DView.h
//  IFS3D
//
//  Copyright (c) 2001 David Leppik.
//

// This is the main view class, and the one which the screen saver program looks for.


#import <ScreenSaver/ScreenSaver.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

#import "IFS3DPreferences.h"
#import "Fractal.h"

// Since we automatically adjust complexity to match a target frame rate,
// the target frame rate needs to be higher than the branch count times the current frame rate,
// so that we can tell when we have wiggle room to increase the branch count.
// So we tell the screen saver to give us 30 FPS * MAX_BRANCHES.
#define MAX_FRAMERATE_SECS  (0.03333333/MAX_BRANCHES)


@interface IFS3DView : ScreenSaverView
{
    NSOpenGLView 	*theGLView;
    BOOL		isGLViewInited;
    
    
    unsigned int	tick;
    NSSize		screenSize;
    
    NSDate		*lastFrameTime;
    NSTimeInterval	estimatedFrameRate;
    
    float		viewRotation;
}

- (void)doAnimation;

- (void)updateFrameRateEstimate;

@end
