/*
 *  MathFunctions.h
 *  IFS3D
 *
 *  Created by David Leppik on Sat Dec 22 2001.
 *  Copyright (c) 2001 David Leppik.
 *
 */

#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

#import <stdio.h>


typedef	GLfloat	POINT[ 3 ];
typedef	GLfloat	VECTOR[ 3 ];
typedef GLfloat MATRIX[ 16];


#define randomPositiveFloat() 	(((float) (random()))/((float) LONG_MAX))
#define randomUnitFloat()  	(((float) (random()))/((float) LONG_MAX/2)-1)
#define randomFloat(min,max)    (  randomPositiveFloat()*(max-min)+min  )

void printMatrix(GLfloat a[16]);
void printPoint(POINT a);

void multMatrix(GLfloat a[16], GLfloat b[16], GLfloat result[16]);

/* Transform point a by matrix m */
void transformPoint(POINT a, GLfloat m[16], POINT result);
    

